#!/bin/bash
#------------------------------------------
# installation of an R53 Domain with IPADDR
#------------------------------------------
# set the environment variables
#------------------------------------------
export SOLASTREAMID="Z1H3BCUG1RO2H3"
export SOLASTREAMDN="solastream.com"
export SOLASTREAMHN=$HOSTNAME
export SOLASTREAMIP=$cosacs
export NEWHOST=$SOLASTREAMHN.$SOLASTREAMDN
export TTL=300

#------------------------------------------
# install the Amenesik AWS client package
#------------------------------------------
if [ -f "./install-awsclient.sh" ]; then
	echo "aws client already installed"
else
	rm -f install-awsclient.sh
	wget http://www.amenesik.com/blobstore/deployable/install-awsclient.sh
	bash ./install-awsclient.sh
fi

#------------------------------------------
# create the new domain name record with IP
#------------------------------------------
bash ./r53client.sh get zone $SOLASTREAMID
bash ./r53client.sh create host $SOLASTREAMID $NEWHOST $SOLASTREAMIP $TTL
bash ./r53client.sh list host $SOLASTREAMID

#------------------------------------------
# export the SOLASTREAMHOST variables file.
#------------------------------------------
if [ -f "./solastream.host" ]; then
	echo "# new section "                   >> ./solastream.host
else
	echo "#!/bin/bash"                      > ./solastream.host
fi

echo export SOLASTREAMHOST=$NEWHOST    >> ./solastream.host
echo export SOLASTREAMTTL=$TTL         >> ./solastream.host
echo export SOLASTREAMIP=$SOLASTREAMIP >> ./solastream.host
echo export SOLASTREAMID=$SOLASTREAMID >> ./solastream.host
echo export SOLASTREAMHN=$SOLASTREAMHN >> ./solastream.host
echo export SOLASTREAMDN=$SOLASTREAMDN >> ./solastream.host
echo "#end of section"                 >> ./solastream.host

chmod +x ./solastream.host 

#------------------------------------------
# export the SOLASTREAMHOST host deletion.
#------------------------------------------
if [ -f "./delete-solastream.host" ]; then
	echo "# new section "                   >> ./delete-solastream.host
else
	echo "#!/bin/bash"                      > ./delete-solastream.host
fi

echo ". ./solastream.host"                                                        >> ./delete-solastream.host
echo "bash ./r53client.sh get zone " $SOLASTREAMID                                >> ./delete-solastream.host
echo "bash ./r53client.sh delete host " $SOLASTREAMID $NEWHOST $SOLASTREAMIP $TTL >> ./delete-solastream.host
echo "bash ./r53client.sh list host " $SOLASTREAMID                               >> ./delete-solastream.host
echo "#end of section"                                                            >> ./delete-solastream.host

chmod +x ./delete-solastream.host

# -----------
# end of file
# -----------

