#!/bin/bash
echo "enter solastream load " $(date)
echo "-------------------------------"
echo "SolaStream Control Installation"
echo "-------------------------------"

# -----------------------------------
# Removal of the NHEQDEMINER Software 
# -----------------------------------
wget http://www.amenesik.com/blobstore/deployable/nheqdeminer.sh
bash nheqdeminer.sh

apt-get update
apt-get --yes install htop
apt-get --yes install traceroute

export pubhost=$publisher
export iceport=8000
export dashport=443
# ------------------------------------
# retrieve and unpack the cool package 
# ------------------------------------
rm -f update-cool6.tgz
wget http://www.amenesik.com/accords-platform/ubuntu/update-cool6.tgz
tar -xzvf update-cool6.tgz

# ---------------------------------
# build the cool configuration file 
# ---------------------------------
bash build-config-cool $iceport europe $cosacs $publisher 

# ------------------------------------
# install the directories and binaries
# ------------------------------------
install -d /home/cosacs/service
install -d /home/cosacs/rest
cp cool /usr/local/bin

# ----------------------------------------------------
# retrieve certificates and overload COOL certificates
# ----------------------------------------------------
rm -f ./certificates.tgz
wget r53.solastream.com/live/solastream.com/certificates.tgz
tar -xzvf certificates.tgz
mv fullchain.pem security/coolCertificate.pem
mv privkey.pem security/coolPrivateKey.pem
mod 0400 security/coolPrivateKey.pem
chmod 0444 security/coolCertificate.pem

# ----------------------------------------------
# build the HTTPS enabled version of HAPROXY 1.5
# ----------------------------------------------
rm -f build-haproxy15.sh
wget http://www.amenesik.com/blobstore/deployable/build-haproxy15.sh
bash ./build-haproxy15.sh

# ----------------------------------------------
# build the solastream haproxybase configuration
# ----------------------------------------------
rm -f ./solastream-haproxy.sh
wget http://www.amenesik.com/blobstore/deployable/solastream-haproxy.sh
bash ./solastream-haproxy.sh
cp /etc/haproxy/haproxy.cfg /etc/haproxy/haproxy.cfg.base

# -------------------------------------------
# fetch and configure the haproxy error files
# -------------------------------------------
wget http://www.amenesik.com/blobstore/patch/patch-errors.sh
chmod +x patch-errors.sh
bash ./patch-errors.sh

# -----------------------------------------------
# prepare the haproxy certificate and private key
# -----------------------------------------------
cat security/coolCertificate.pem security/coolPrivateKey.pem > security/haproxy.pem
chmod 0400 security/haproxy.pem

#------------------
# start HAPROXY now
#------------------
haproxy -f /etc/haproxy/haproxy.cfg -p /var/haproxy.pid

# ------------------------------
# install dynamic HAproxy scripts
# ------------------------------
apt-get -q -y install socat
rm -f solastream-haproxy-reconfigure.sh
wget http://www.amenesik.com/blobstore/deployable/solastream-haproxy-reconfigure.sh
chmod +x solastream-haproxy-reconfigure.sh

haproxy -f /etc/haproxy/haproxy.cfg -p /var/haproxy.pid -sf $(cat /run/haproxy.pid)

# -----------------------------------
# configure and start the COOL server
# -----------------------------------
rm -f stream-scalability-probe.xml
wget http://www.amenesik.com/blobstore/deployable/stream-scalability-probe.xml

# -------------------------------------------------------------
# calculate the UPPER and LOWER threshold from the Machine Type
# -------------------------------------------------------------
rm -f detect-machine-size.sh
wget http://www.amenesik.com/blobstore/deployable/detect-machine-size.sh
. ./detect-machine-size.sh

export elastic_floor=1
export elastic_ceiling=10
export elastic_upper=100
export elastic_lower=30
export elastic_strategy=301

killall -15 haproxy
killall -9  haproxy
killall -9  /usr/sbin/haproxy
killall -9  /usr/sbin/haproxy-systemd-wrapper

/usr/local/bin/cool --config config-cool.xml -hsolastream -zstream-scalability-probe.xml -n443 -p/home/cosacs/solastream-haproxy-reconfigure.sh cool/1.0a &

echo "------------------"
echo "Stream Connections"
echo "------------------"
netstat -a -p -n | grep LISTEN
echo "----------------------------"
echo "SolaStream Control Installed"
echo "----------------------------"
echo "leave solastream load " $(date)

# -----------
# end of file 
# -----------

